package u8c.ui.mm.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.framework.common.NCLocator;
import nc.hr.utils.PubEnv;
import nc.itf.uap.IUAPQueryBS;
import nc.itf.uap.IVOPersistence;
import nc.itf.uap.pf.IplatFormEntry;
import nc.jdbc.framework.processor.ColumnProcessor;
import nc.ui.hr.frame.FrameUI;
import nc.ui.hr.frame.action.AbstractAction;
import nc.ui.hr.frame.impl.MainBillMgrPanel;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.MessageDialog;
import nc.vo.OperationMainVO;
import nc.vo.OperationPurchaseVO;
import nc.vo.hr.tools.pub.HRAggVO;
import nc.vo.pr.pray.PraybillHeaderVO;
import nc.vo.pr.pray.PraybillItemVO;
import nc.vo.pr.pray.PraybillVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.ValidationException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import u8c.ui.mm.panel.OperationMainPanel;
import u8c.ui.mm.panel.OperationTestUI;

public class PushParybillAction extends AbstractAction {

	private IUAPQueryBS iuap=(IUAPQueryBS) NCLocator.getInstance().lookup(IUAPQueryBS.class.getName());
	OperationTestUI frameUI = null;
	public PushParybillAction(FrameUI frameUI) {
		super(frameUI);
		this.frameUI = (OperationTestUI) frameUI;
	}

	@Override
	public void execute() throws Exception {
		MainBillMgrPanel mainMgrPanel = (MainBillMgrPanel) getMainPanel();
		int selectedRow = ((OperationMainPanel) getMainPanel()).getSelectedRow();
		HRAggVO s = (HRAggVO) mainMgrPanel.getMainBillCardPanel().getData();

		if (null != s ) {
			OperationMainVO headvo = (OperationMainVO) s.getParentVO();
			int billstatus = headvo.getBillstatus();
			if (billstatus != 1) {
				throw new ValidationException("非审批态单据不允许生成请购单！");
			}
//			ToParyBillDialog toParyBillDialog = new ToParyBillDialog(s);
//			toParyBillDialog.show();
			//生成请购单
			OperationPurchaseVO[]  operationpurs=getPurArrays(s);
			if(null==operationpurs || operationpurs.length==0) {
				throw new ValidationException("没有需要生成的请购单！");
			}else {
				
				IplatFormEntry iIplatFormEntry = (IplatFormEntry)NCLocator.getInstance().lookup(IplatFormEntry.class.getName());
				
				List<PraybillVO> getaggvos =getaggvos(operationpurs,headvo);
				if(null!=getaggvos && getaggvos.size()>0) {
					for(PraybillVO vo:getaggvos) {
						   iIplatFormEntry.processAction("SAVEBASE", "20", vo.getHeadVO().getDpraydate().toString(), null, vo, null, null);	
						 //  iIplatFormEntry.processAction("APPROVE", "20", vo.getHeadVO().getDpraydate().toString(), null, vo, null, null);
						}
						
					
					MessageDialog.showHintDlg(frameUI, "成功", "请购单新增成功!");
				}else {
					
					MessageDialog.showHintDlg(frameUI, "提示", "请购单没有数据!");
					
				}
				
				
			}
		}
	}
	
	
	// 根据传入的aggvo获取purvo数组
	private OperationPurchaseVO[] getPurArrays(HRAggVO aggvo) {
		CircularlyAccessibleValueObject[] vos = aggvo.getAllChildrenVO();
		List<OperationPurchaseVO> purvos = new ArrayList<OperationPurchaseVO>();
		for (CircularlyAccessibleValueObject vo : vos) {
			if (vo instanceof OperationPurchaseVO) {
				OperationPurchaseVO purvo = (OperationPurchaseVO) vo;
				purvos.add(purvo);
			}
		}
		OperationPurchaseVO[] purArrays = purvos.toArray(new OperationPurchaseVO[0]);
		return purArrays;
	}
	
	
	
	private  List<PraybillVO> getaggvos(OperationPurchaseVO[] opervos,OperationMainVO headvo) throws Exception{
		Map<String,List<OperationPurchaseVO>> map=new HashMap<String,List<OperationPurchaseVO>>();//key 材料采购单主表主键
		for(int i=0;i<opervos.length;i++) {
			OperationPurchaseVO cagvo=opervos[i];
			List<OperationPurchaseVO> vos=map.get(cagvo.getVdef29());
			if(null!=vos && vos.size() >0 ) {
				vos.add(cagvo);
				map.put(cagvo.getVdef29(), vos);
			}else {
				List<OperationPurchaseVO> vosnew=new ArrayList<OperationPurchaseVO>();
				vosnew.add(cagvo);
				map.put(cagvo.getVdef29(), vosnew);
			}
		}
		
		 List<PraybillVO> aggvos=new ArrayList<PraybillVO>();
		 for (Map.Entry<String,List<OperationPurchaseVO>> entry : map.entrySet()) {
			    PraybillVO aggvo = new PraybillVO();
				PraybillHeaderVO header = new PraybillHeaderVO();
				header.setPk_corp(PubEnv.getCorpCode());// 公司
				header.setCoperator(ClientEnvironment.getInstance().getUser().getPrimaryKey());// 制单人
				header.setDpraydate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));// 请购日期-->制单日期
				header.setIbillstatus(0);// 单据状态
//				header.setCpraypsn("1001V510000000000292");//请购人id-->业务员
//				header.setCdeptid("1001V510000000000276");//请购部门id-->计划部门
				header.setVmemo("MRP运算清单");// 备注
				header.setDr(0);
				header.setCaccountyear(String.valueOf(new UFDate().getYear()));// 年份
				header.setIpraysource(5);// 请购来源
				header.setIpraytype(2);// 请购类型 
				//项目编码 pk_defdoc9
				header.setAttributeValue("pk_defdoc9", headvo.getProjectid());
				//项目名称pk_defdoc10
				header.setAttributeValue("pk_defdoc10", headvo.getProjectid());
				//加工单号pk_defdoc2
				header.setAttributeValue("pk_defdoc2", entry.getKey());
				
				List<OperationPurchaseVO> lispurvos=entry.getValue();
				PraybillItemVO[] items = new PraybillItemVO[lispurvos.size()];
				for(int j=0;j<lispurvos.size();j++) {
					OperationPurchaseVO zbvo=lispurvos.get(j);
					PraybillItemVO praybillItemVO = new PraybillItemVO();
					praybillItemVO.setPk_corp(PubEnv.getCorpCode()); // 公司
					praybillItemVO.setPk_purcorp (PubEnv.getCorpCode());//采购公司

					// 表体赋值
					praybillItemVO.setCmangid(getCmangchid(getCmangid(zbvo.getCmaterialcode()))); //存货编码
					praybillItemVO.setCbaseid(getCmangid(zbvo.getCmaterialcode())); //存货基础ID 
//					praybillItemVO.setNpraynum(new UFDouble(zbvo.getNum())); //数量
					praybillItemVO.setNpraynum(new UFDouble(zbvo.getVdef26())); //数量
					praybillItemVO.setNassistnum (zbvo.getNastnum());//辅计量数量
					String cprojectid = headvo.getProjectid();//项目id
					praybillItemVO.setCprojectid(cprojectid);
//					praybillItemVO.setCassistunit(demandBVO.getCastunitid());//辅助计量单位
//					praybillItemVO.setNassistnum(new UFDouble(demandBVO.getNastnum()));//辅计量数量
//					praybillItemVO.setVproducenum(cgdd.getVbatchcode());//批次号
					praybillItemVO.setDdemanddate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
					praybillItemVO.setDsuggestdate(new UFDate(ClientEnvironment.getInstance().getBusinessDate().toString()));
//					praybillItemVO.setPk_purcorp(PubEnv.getCorpCode());
					praybillItemVO.setPk_reqcorp(PubEnv.getCorpCode());
					praybillItemVO.setAttributeValue("pk_defdoc1",zbvo.getVdef1() );//楼号楼层
					praybillItemVO.setAttributeValue("pk_defdoc2", zbvo.getVdef2());//樘数（数量）
					praybillItemVO.setAttributeValue("pk_defdoc3", zbvo.getVdef3());//框统计
					praybillItemVO.setAttributeValue("pk_defdoc4", zbvo.getVdef4());//扇统计
					praybillItemVO.setAttributeValue("pk_defdoc5", zbvo.getVdef5());//半成品分类
					praybillItemVO.setAttributeValue("pk_defdoc6", zbvo.getVdef6());//面积
					praybillItemVO.setAttributeValue("pk_defdoc7", zbvo.getVdef7());//切割长度
					praybillItemVO.setAttributeValue("pk_defdoc8", zbvo.getVdef8());//切割角度左下
					praybillItemVO.setAttributeValue("pk_defdoc9", zbvo.getVdef9());//切割角度右上
					praybillItemVO.setAttributeValue("pk_defdoc10",zbvo.getVdef10());//备注
					praybillItemVO.setAttributeValue("pk_defdoc11",zbvo.getWidth());//宽度
					praybillItemVO.setAttributeValue("pk_defdoc12",zbvo.getHeight());//高度
					praybillItemVO.setAttributeValue("pk_defdoc13",zbvo.getVdef11());//系列
					praybillItemVO.setAttributeValue("pk_defdoc14",zbvo.getVdef12());//玻璃编号
					
					praybillItemVO.setCassistunit(getMeasidByNames(zbvo.getCastunitid()));//辅计量单位ID 
					
					praybillItemVO.setVproducenum (zbvo.getVbatchcode());
					praybillItemVO.setVfree1(zbvo.getColor());
					praybillItemVO.setVfree2(zbvo.getAlloy());
					praybillItemVO.setVfree3(zbvo.getSizing());
					praybillItemVO.setVfree4(zbvo.getStandard());
					
					items[j]=praybillItemVO;
				}
				aggvo.setParentVO(header);
				aggvo.setChildrenVO(items);
				aggvos.add(aggvo);
			 
		    }
		
		  return aggvos;
	}
	
	
	 /**
		 * 存货管理档案
		 * @param code
		 * @return
		 * @throws BusinessException
		 */
	public String getCmangchid(String pk_invbasdoc) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invmandoc from bd_invmandoc" + " where pk_invbasdoc  ='" + pk_invbasdoc + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + pk_invbasdoc);
		}
		return cmangid;
	}
	
    /**
	 * 根据物料code查询主键
	 * @param code
	 * @return
	 * @throws BusinessException
	 */
	public String getCmangid(String code) throws BusinessException {
		String cmangid = null;
		String sql = " select pk_invbasdoc from bd_invbasdoc" + " where invcode  ='" + code + "' and dr =0 ";
		cmangid = (String) iuap.executeQuery(sql, new ColumnProcessor());
		if (cmangid == null) {
			throw new BusinessException("U8C物料code不存在:" + code);
		}
		return cmangid;
	}
	
	
	
	//根据计量单位名称获取主键
    public  String getMeasidByNames(String measname) throws Exception {
        String sql = "select pk_measdoc from bd_measdoc where isnull(dr,0) = 0 and measname = '"+measname+"'";
        return (String) iuap.executeQuery(sql, new ColumnProcessor());
    }
	
	
	
	
	
	
}












